<script setup lang="ts">
import Modal from '@/components/general/Modal.vue';
import Input from '../general/form/Input.vue';
import { inject, onMounted, ref } from 'vue';
import { storeToRefs } from 'pinia';
import { request } from '@/lib/request';
import { useChatStore } from '@/stores/chat';
import { useI18n } from 'vue-i18n';

const { t } = useI18n();
const $t = t;

const emits = defineEmits<{
    (e: 'close'):void,
    (e: 'submit', uuid:string):void
}>();

const store = useChatStore();
const { uuid, state } = storeToRefs(store);

const configuration = inject<any>('configuration');

onMounted(async ()=>{
    if ((state.value === 'CHAT_COPY' || state.value === 'PERSON_CHAT_COPY' || state.value === 'IMAGE_COPY') && uuid.value) {
        const result = await request('GET', configuration.apiServer + "/api/ai/chat/" + uuid.value, undefined, 'application/json', undefined, true);
        if (result.success) {
            name.value = $t('general.variables.copy') +  result.chat.name;
        }
    }
});

const name = ref('');

const handleSubmit = async()=>{
    const data = { name: name.value };
    const result = await request('POST', configuration.apiServer + "/api/ai/chat/" + uuid.value + "/copy", data, 'application/json', undefined, true);
    if(result.success)
        emits('submit', result.uuid);
};

const handleCancel = ()=>{
    emits('close');
};

</script>
<template>
<Modal :header="$t('ai.general.copy.header')" :labelSubmit="$t('contentPage.copyLabel')" :disableSubmit="name.length===0" :labelCancel="$t('general.buttons.cancel')" @cancel="handleCancel" @submit="handleSubmit">
    <Input v-model="name" type="text" :label="$t('ai.chat.create.name.label')" :placeholder="$t('ai.chat.create.name.placeholder')"/>
</Modal>
</template>